Index: trunk/packages/invirt-console-server/debian/changelog
===================================================================
--- trunk/packages/invirt-console-server/debian/changelog	(revision 1740)
+++ trunk/packages/invirt-console-server/debian/changelog	(revision 1741)
@@ -1,2 +1,8 @@
+invirt-console-server (0.1.1) unstable; urgency=low
+
+  * Clean up the init script with some ideas from debathena-pyhesiodfs.
+
+ -- Evan Broder <broder@mit.edu>  Sat, 22 Nov 2008 05:25:54 -0500
+
 invirt-console-server (0.1.0) unstable; urgency=low
 
Index: trunk/packages/invirt-console-server/debian/invirt-console-server.init
===================================================================
--- trunk/packages/invirt-console-server/debian/invirt-console-server.init	(revision 1740)
+++ trunk/packages/invirt-console-server/debian/invirt-console-server.init	(revision 1741)
@@ -19,5 +19,6 @@
 NAME=invirt-console-server
 DAEMON=/usr/bin/invirt-consolefs
-DAEMON_ARGS="/consolefs"
+MOUNTPOINT="/consolefs"
+DAEMON_ARGS="-f $MOUNTPOINT"
 PIDFILE=/var/run/$NAME.pid
 SCRIPTNAME=/etc/init.d/$NAME
@@ -56,8 +57,15 @@
     #   1 if daemon was already running
     #   2 if daemon could not be started
-    modprobe fuse
+    
+    # Try to make sure fuse is setup
+    [ -e /dev/fuse ] || modprobe fuse || return 2
+    
+    if cat /proc/mounts | grep " $MOUNTPOINT " >/dev/null 2>&1; then
+        return 1
+    fi
+    
     gen_config
-    daemon --running -n $NAME && return 1
-    daemon -r -O daemon.info -E daemon.err -n $NAME -U $DAEMON $DAEMON_ARGS || return 2
+    
+    daemon -r -O daemon.info -E daemon.err -n $NAME -- $DAEMON $DAEMON_ARGS || return 2
 }
 
@@ -72,4 +80,9 @@
     #   2 if daemon could not be stopped
     #   other if a failure occurred
+    
+    if ! cat /proc/mounts | grep " $MOUNTPOINT " >/dev/null 2>&1; then
+        return 1
+    fi
+    
     daemon --stop -n $NAME
     RETVAL="$?"
@@ -77,6 +90,4 @@
     # Many daemons don't delete their pidfiles when they exit.
     rm -f $PIDFILE
-    umount "$DAEMON_ARGS"
-    return "$RETVAL"
 }
 
